package com.unipi.talepis;

import java.util.function.*;

public class Main {

    public static void main(String[] args) {
	    new Student().saySomething();
        useSpeaker(new Student());
        useSpeaker(new ISpeak() {
            void hello(){
                System.out.println("Hello");
            }
            @Override
            public void speak(String message) {
                hello();
                System.out.println("Wow "+message);
            }
        });
        useSpeaker((s)-> {System.out.println("Good morning "+s);});
        Function<String,String> myFunction1 = (s)-> {return "hello "+s;};
        Function<String,String> myFunction2 = (s)-> "hello "+s;
        System.out.println(myFunction1.apply("Informatics"));
        Predicate<Student> checkAge = student -> student.age>18;
        Student s1 = new Student();
        s1.age = 20;
        System.out.println(checkAge.test(s1));
        Supplier<Student> studentRandomAgeSupplier = ()->{
                Student st = new Student();
                st.age = (int)(100*Math.random());
                return st;
        };
        System.out.println(studentRandomAgeSupplier.get().age);
        System.out.println(studentRandomAgeSupplier.get().age);
        Consumer<Student> studentConsumer =
                student -> System.out.println("Age:"+student.age);
        BinaryOperator<Student> someTest =
                (st1,st2)->new Student(st1.age+st2.age);
        System.out.println(
                someTest.apply(studentRandomAgeSupplier.get(),
                        studentRandomAgeSupplier.get()).age);
    }
    static void useSpeaker(ISpeak iSpeak){
        iSpeak.speak("Unipi");
    }
}
